#ifndef CommandHandler_H
#define CommandHandler_H

#include <Arduino.h>
#include <Wire.h>
#include <CommandBuffer.h>
#include <ICommandListener.h>
#include <Command.h>
#include <CommandCodes.h>

extern int CURRENT_DEVICE_ADDRESS;

class CommandHandler
{
public:
  static CommandHandler *getInstance();
  void run();
  void configure(int DEVICE_ADDRESS, ICommandListener *listener);
  void configure(int DEVICE_ADDRESS, void (*)(Command *)); // Static callback
  void send(Command *command);
  static void receiveCommand(int howMany);
  
  ICommandListener *getListener();

private:
  static CommandHandler *_instance;
  CommandHandler();
  void transmitCommands();

  CommandBuffer _cmdBuffer;
  ICommandListener *_listener = NULL;
  static void (*_staticProcessCommand)(Command *) = NULL;
  
};

#endif
